import { world, system, ItemStack } from '@minecraft/server';

const cropList = [
	'minecraft:carrots',
	'minecraft:potatoes',
	'minecraft:beetroot',
	'minecraft:wheat'
];
const rotations = [ '0_degrees', '90_degrees', '180_degrees', '270_degrees' ];
const mirror = [ 'x', 'z' ];

world.afterEvents.itemUseOn.subscribe(e =>{
	let player = e.source;
	let item = e.itemStack;
	let block = e.block;
	if(item.typeId != 'minecraft:bone_meal' || !cropList.includes(block.typeId)) return;
	if(block.permutation.getState('growth') != 7) return;
	player.runCommand('clear @s[m=!c] bone_meal 0 1');
	block.dimension.runCommand(`particle minecraft:crop_growth_emitter ${block.x} ${block.y} ${block.z}`);
	generateMegaCrop(cropList[cropList.indexOf(block.typeId)], block);
});

function generateMegaCrop(c, b){
	let chance = Math.floor(Math.random() * 10);
	if(chance != 9) return;
	switch(c){
		case 'minecraft:carrots':
			if(randomize(10) == 9){
				b.dimension.runCommand(`structure load mega_crops:super_mega_carrot ${b.x - 4} ${b.y - 26} ${b.z - 3} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
			}
			else{
				if(randomize(2) == 1){
					b.dimension.runCommand(`structure load mega_crops:mega_carrot1 ${b.x - 2} ${b.y - 12} ${b.z - 3} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
				}
				else{
					b.dimension.runCommand(`structure load mega_crops:mega_carrot1 ${b.x - 2} ${b.y - 11} ${b.z - 2} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
				}
			}
			break;
		case 'minecraft:potatoes':
			if(randomize(2) == 1){
				if(randomize(2) == 1){
					b.dimension.runCommand(`structure load mega_crops:mega_potato ${b.x - 2} ${b.y - 6} ${b.z - 2} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
				}
				else{
					b.dimension.runCommand(`structure load mega_crops:super_mega_potato ${b.x - 5} ${b.y - 10} ${b.z - 5} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
				}
			}
			else{
				if(randomize(2) == 1){
					b.dimension.runCommand(`structure load mega_crops:mega_poisonous_potato ${b.x - 2} ${b.y - 6} ${b.z - 2} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
				}
				else{
					b.dimension.runCommand(`structure load mega_crops:super_mega_poisonous_potato ${b.x - 5} ${b.y - 10} ${b.z - 5} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
				}
			}
			break;
		case 'minecraft:beetroot':
			if(randomize(2) == 1){
				if(randomize(2) == 1){
					b.dimension.runCommand(`structure load mega_crops:mega_beetroot1 ${b.x - 1} ${b.y - 3} ${b.z - 1} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
				}
				else{
					b.dimension.runCommand(`structure load mega_crops:mega_beetroot2 ${b.x - 1} ${b.y - 4} ${b.z - 1} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
				}
			}
			else{
				b.dimension.runCommand(`structure load mega_crops:super_mega_beetroot ${b.x - 3} ${b.y - 8} ${b.z - 3} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
			}
			break;
		case 'minecraft:wheat':
			if(randomize(2) == 1){
				b.dimension.runCommand(`structure load mega_crops:mega_wheat ${b.x - 2} ${b.y} ${b.z - 2} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
			}
			else{
				b.dimension.runCommand(`structure load mega_crops:super_mega_wheat ${b.x - 3} ${b.y} ${b.z - 3} ${rotations[randomize(3)]} ${mirror[randomize(2)]}`);
			}
			break;
		default:
			break;
	}
}

function randomize(m){
	return Math.floor(Math.random() * m);
}